# nexus server

## SYNOPSIS

    nexus server (with no args)
    nexus server start [-c <path to configFile>]
    nexus server stop
    nexus server restart
    nexus server reboot [-c <path to configFile]
    nexus server version
    
## DESCRIPTION

This command can be used to control the nexus-server. The nexus-server will 
listen on a `<host>:<port>` or on a unix-socket (or both) which can be defined
in the config.

* the default-configFile-path is ~/.nexus/config.js
* `nexus server start` will reset the nexus-database
* `nexus server reboot` will start all apps stored in the nexus-database before 
  it resets the database.
  so when you reboot while some apps are still running every app will run 2x.
  `nexus server reboot` is meant to be run after a system-reboot (e.g. one can
  write a `init.d`-script and put `nexus reboot` in it).
* it is possible to start multiple nexus-servers - where every server listens
  on different ports/unix-sockets. note that monitor-servers will only connect
  to one nexus-server.

## EXAMPLES

* `nexus server`
    * will print information about the local nexus-server
* `nexus -r foo server`
    * will print information about the remote nexus-server
* `nexus server start -c /path/to/config.js`
    * will start the server and `require('/path/to/config.js')`
* `nexus server stop`
    * will stop the local running nexus-server
* `nexus server restart`
* `nexus server reboot`
* `nexus server version`
    * will print the version of the local running nexus-server
